/*
 @licstart  The following is the entire license notice for the JavaScript code in this page.

 Copyright (C) 2014-2020, Josef Hahn

 This file is part of Yaji.

 Yaji is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Yaji is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

 @licend  The above is the entire license notice for the JavaScript code in this page.
*/


function htmlEncode(s) {
    var dummyelement = document.createElement("p");
    dummyelement.textContent = s||"";
    return dummyelement.innerHTML;
}

function htmlDecode(h) {
    var dummyelement = document.createElement("p");
    dummyelement.innerHTML = h||"";
    return dummyelement.textContent;
}

function rot13(txt) {
    function rot13section(s, a, b) {
        var ia = a.charCodeAt(0);
        var ib = b.charCodeAt(0);
        var result = "";
        for (var ch of s) {
            var ich = ch.charCodeAt(0);
            result += String.fromCharCode((ia <= ich && ich <= ib) ? ((ich - ia + 13) % 26 + ia) : ich);
        }
        return result;
    }
    return rot13section(rot13section(txt||"", 'a', 'z'), 'A', 'Z');
}

class FooConverter extends clove.DataBindingConverter {

    convertTo(x) {
        return htmlDecode(x);
    }

    convertFrom(y) {
        return htmlEncode(y);
    }

}

class BarConverter extends clove.DataBindingConverter {

    convertTo(x) {
        return rot13(htmlDecode(x));
    }

    convertFrom(y) {
        return htmlEncode(rot13(y));
    }

}
