/*
 @licstart  The following is the entire license notice for the JavaScript code in this page.

 Copyright (C) 2014-2020, Josef Hahn

 This file is part of Yaji.

 Yaji is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Yaji is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

 @licend  The above is the entire license notice for the JavaScript code in this page.
*/


class MyCurtain extends yaji.Curtain {

    constructor(widgetname) {
        super();
        this.widgetname = widgetname;
    }

    close() {
        clove.getByName(this.widgetname).setBusy(true);
    }

    open() {
        clove.getByName(this.widgetname).setBusy(false);
    }

}

mycurtain0 = new MyCurtain('btn0');
mycurtain1 = new MyCurtain('btn1');

yaji.ready(()=>{
    var eh10 = clove.getByName("eh10");
    var eh11 = clove.getByName("eh11");
    eh10.OnChanged.addHandler(()=>{
        mycurtain1.execute(()=>{
            yaji.ajax({url: 'set_h10', data: {v: eh10.text()}});
        });
    });
    eh11.OnChanged.addHandler(()=>{
        mycurtain1.execute(()=>{
            yaji.ajax({url: 'set_h11', data: {v: eh11.text()}});
        });
    });
});
