#!/usr/bin/python3

# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="boolean bindings", stop_implicitly_when_browser_closed=True)
        self.setbodyleft(yaji.Grid(
            yaji.View(label="local", style="font-size:1.4em", row=0, col=1),
            yaji.View(label="server", style="font-size:1.4em", row=0, col=2),

            yaji.View(label="checkbuttons", style="font-size:1.4em", row=1),
            yaji.View('CheckButton', label="something fooish", row=2, col=1, checked=self.bindlocal('h10')),
            yaji.View('CheckButton', label="something barish", row=2, col=2, checked=self.bindserver('h11')),
            yaji.View('CheckButton', label="something fooish", row=3, col=1, checked=self.bindlocal('h10')),
            yaji.View('CheckButton', label="something barish", row=3, col=2, checked=self.bindserver('h11')),

        ))


if __name__ == '__main__':
    Application().start()
