#!/usr/bin/python3

# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="numeric bindings", stop_implicitly_when_browser_closed=True)
        self.setbodyleft(yaji.Grid(
            yaji.View(label="local", style="font-size:1.4em", row=0, col=1),
            yaji.View(label="server", style="font-size:1.4em", row=0, col=2),

            yaji.View(label="slider and editbox", style="font-size:1.4em", row=1),
            yaji.View('Slider', row=2, col=1, value=self.bindlocal('h10'), max=40),
            yaji.View('Slider', row=2, col=2, value=self.bindserver('h11'), max=40),
            yaji.View('EditBox', row=3, col=1, text=self.bindlocal('h10')),
            yaji.View('EditBox', row=3, col=2, text=self.bindserver('h11')),

            yaji.View(label="radiobuttons", style="font-size:1.4em", row=4),
            yaji.HorizontalStack(
                yaji.View('RadioButton', label="foo", group="A", groupValue=self.bindlocal('h20')),
                yaji.View('RadioButton', label="bar", group="A", groupValue=self.bindlocal('h20')),
                row=5, col=1
            ),
            yaji.HorizontalStack(
                yaji.View('RadioButton', label="foo", group="B", groupValue=self.bindserver('h21')),
                yaji.View('RadioButton', label="bar", group="B", groupValue=self.bindserver('h21')),
                row=5, col=2
            ),
            yaji.HorizontalStack(
                yaji.View('RadioButton', label="Foo", group="C", groupValue=self.bindlocal('h20')),
                yaji.View('RadioButton', label="Bar", group="C", groupValue=self.bindlocal('h20')),
                row=6, col=1
            ),
            yaji.HorizontalStack(
                yaji.View('RadioButton', label="Foo", group="D", groupValue=self.bindserver('h21')),
                yaji.View('RadioButton', label="Bar", group="D", groupValue=self.bindserver('h21')),
                row=6, col=2
            ),

        ))


if __name__ == '__main__':
    Application().start()
