#!/usr/bin/python3

# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="text bindings", stop_implicitly_when_browser_closed=True)
        self.setbodyleft(yaji.Grid(
            yaji.View(label="local", style="font-size:1.4em", row=0, col=1),
            yaji.View(label="server", style="font-size:1.4em", row=0, col=2),

            yaji.View(label="editbox and label", style="font-size:1.4em", row=1),
            yaji.View('EditBox', row=2, col=1, text=self.bindlocal('h00')),
            yaji.View('EditBox', row=2, col=2, text=self.bindserver('h01')),
            yaji.View('Label', row=3, col=1, label=self.bindlocal('h00'), style="color:slategray", height="2em"),
            yaji.View('Label', row=3, col=2, label=self.bindserver('h01'), style="color:slategray"),

            yaji.View(label="editboxes bidirectional", style="font-size:1.4em", row=4),
            yaji.View('EditBox', row=5, col=1, text=self.bindlocal('h10')),
            yaji.View('EditBox', row=5, col=2, text=self.bindserver('h11')),
            yaji.View('EditBox', row=6, col=1, text=self.bindlocal('h10')),
            yaji.View('EditBox', row=6, col=2, text=self.bindserver('h11')),

            yaji.View(label="editboxes to bottom", style="font-size:1.4em", row=7),
            yaji.View('EditBox', row=8, col=1, text=self.bindlocal('h20', yaji.BindDirection.ToDatasource)),
            yaji.View('EditBox', row=8, col=2, text=self.bindserver('h21', yaji.BindDirection.ToDatasource)),
            yaji.View('EditBox', row=9, col=1, text=self.bindlocal('h20', yaji.BindDirection.ToWidget)),
            yaji.View('EditBox', row=9, col=2, text=self.bindserver('h21', yaji.BindDirection.ToWidget)),

            yaji.View(label="editboxes to top", style="font-size:1.4em", row=10),
            yaji.View('EditBox', row=11, col=1, text=self.bindlocal('h30', yaji.BindDirection.ToWidget)),
            yaji.View('EditBox', row=11, col=2, text=self.bindserver('h31', yaji.BindDirection.ToWidget)),
            yaji.View('EditBox', row=12, col=1, text=self.bindlocal('h30', yaji.BindDirection.ToDatasource)),
            yaji.View('EditBox', row=12, col=2, text=self.bindserver('h31', yaji.BindDirection.ToDatasource)),

        ))


if __name__ == '__main__':
    Application().start()
