#!/usr/bin/python3

# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="trees", stop_implicitly_when_browser_closed=True)
        sopts = dict(allowSelection=True, showChangeMenu=True, editOnGesture=True,
                     style="min-height:40pt; min-width:40pt;")
        with self.create_clientlocal_datastore() as clientds:
            for i in range(3):
                clientds.insertrow(i, values=[f"foo {i}"])
        with self.create_datastore() as serverds:
            for i in range(3):
                serverds.insertrow(i, values=[f"bar {i}"])
        self.setbodyleft(yaji.Grid(
            yaji.View(label="local datasource", style="font-size:1.4em", row=0),

            yaji.View('TreeView', row=1, col=1, datasource=clientds, **sopts),
            yaji.View(label="vs.", style="font-size:1.4em", row=2, col=2),
            yaji.View('TreeView', row=3, col=1, datasource=clientds, **sopts),

            yaji.View(label="server datasource", style="font-size:1.4em", row=4),

            yaji.View('TreeView', row=5, col=1, datasource=serverds, **sopts),
            yaji.View(label="vs.", style="font-size:1.4em", row=6, col=2),
            yaji.View('TreeView', row=7, col=1, datasource=serverds, **sopts),

        ))


if __name__ == '__main__':
    Application().start()
