# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

"""!
Web based user interfaces running in a local browser on top of clove.

Read about app.Application and its methods for more details.

The user interface is implemented on browser side by the clove library. See https://pseudopolis.eu/wiki/pino/projs/clove
for a documentation about availablewidgets and more details.

Also take a look at the sample apps in `_meta/sampleapps`. Each `.py` file there which does not begin with `_` is one
application. Some might also have a javascript and/or stylesheet file (named like `__foo.js`).
"""

from .core import Directories, Middleware, log
from .guibase import *
from .gui import *
from .i18n import TrStr
from .reqhandler import RequestHandler
from .app import Application


"""
TODO# migrate to new approach
projects/parsley/parsley/gui/Yaji: reporting, mainapp, conflicts
workbench/projectlets/MissionDashboard/Yaji
workbench/projectlets/SharedArticlesTagger/streamer_client/Yaji
workbench/projectlets/PiMoney/webclient/Yaji
workbench/projectlets/CressSeedTest/Yaji
"""

# TODO# keyboard support (menu shortcuts, ...)
# TODO# make clove work with real javascript properties
