# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of anise.
#
# anise is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# anise is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with anise.  If not, see <http://www.gnu.org/licenses/>.

"""
Feature for generic unit testing.
"""

import anise.framework.features
import anise.utils

testing = anise.framework.features.loadfeature("testing").featuremodule


def generictest(testrun, command):
    """!
    Runs an external command as test and interpret it as successful, if the return value is 0.
    @param testrun: A testing.internals.TestRun instance.
    @param command: The external command (as list of strings).
    """
    testrun.begintest()
    r, o = anise.utils.basic.call(*command)
    success = testing.internals.TestRun.SUCCESS_SUCCESSFUL if (r == 0) else testing.internals.TestRun.SUCCESS_FAILED
    testrun.endtest(o, success)
