# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of anise.
#
# anise is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# anise is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with anise.  If not, see <http://www.gnu.org/licenses/>.

"""
Feature for helpers related to terminal-based user interfaces.
"""

import sys


def showhead(head, msg, withterm=True):
    sys.stderr.originalstream.write("\n\033[30;104m\n{0}\n\033[30;107m\n{1} \033[33;107m""".format(head, msg))
    if withterm:
        sys.stderr.originalstream.write("\033[0m\n")


def prompt(head, msg):
    showhead(head, msg, withterm=False)
    res = sys.stdin.readline()
    sys.stderr.originalstream.write("\033[0m\n")
    if res.endswith("\n") or res.endswith("\r"):
        res = res[:-1]
    return res
