# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of anise.
#
# anise is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# anise is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with anise.  If not, see <http://www.gnu.org/licenses/>.

import anise.test.anisetest


_projectdesc = """<?xml version="1.0" ?>
<aniseprojectdesc>
    <val k="foo" t="int" v="1" />
    <val k="bar" t="int" v="2" />
    <val k="sum" oref="lambda: foo + bar" />
    <val k="sum2" oref="lambda a,b: a + b" />
    <val k="sum2exec" t="files.TaskExecution">
        <val k="task" oref="sum2" />
        <val k="a" oref="foo" />
    </val>
    <val k="sum3" oref="lambda: sum2(a=foo, b=universe.bar)" />
</aniseprojectdesc>
"""


class Test(anise.test.anisetest.AniseTestCase):

    def __init__(self, *a, **kwa):
        anise.test.anisetest.AniseTestCase.__init__(self, *a, projectdesc=_projectdesc, **kwa)

    def test_a(self):
        self.assertEqual(self.runanise("sum"), 3)
        self.assertEqual(self.runanise("sum", values={'foo': 3}), 5)
        self.assertEqual(self.runanise("sum3"), 3)
