# Copyright (C) 2014-2020, Josef Hahn
#
# This file is part of anise.
#
# anise is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# anise is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with anise.  If not, see <http://www.gnu.org/licenses/>.

import anise.test.anisetest


_projectdesc = """<?xml version="1.0" ?>
<aniseprojectdesc>
    <val k="foo" t="int" v="1" />
    <val k="bar" t="int" v="-17" />
    <let k="base.pyscript">
        <val k="hook" oref="engine.HOOK_AFTER_PREPARATION"/>
        <val k="code">
def fct():
    def sum():
        setvalue("bar", 1)
        return getvalue("foo") + getvalue("bar") + getvalue("baz", 1)
    universe.sum=sum
        </val>
    </let>
    <let k="base.pytask" taskname="sum2">
        <val k="code">
if True:
    setvalue("bar", 1)
    setvalue("base.v1", 1)
return getvalue("foo") + getvalue("bar") + getvalue("baz", 1) + getvalue("base.v1") + getvalue("base.v2", 1)
        </val>
    </let>
</aniseprojectdesc>
"""


class Test(anise.test.anisetest.AniseTestCase):

    def __init__(self, *a, **kwa):
        anise.test.anisetest.AniseTestCase.__init__(self, *a, projectdesc=_projectdesc, **kwa)

    def test_a(self):
        self.assertEqual(self.runanise("sum"), 3)

    def test_b(self):
        self.assertEqual(self.runanise("sum2"), 5)
